AccountReps = nil
RGSettings = nil

RepGrinder = CreateFrame("FRAME")
RepGrinder.PlayerID = UnitGUID("player")
RepGrinder.ResetSession = false;
RepGrinder.ReadyForRepUpdates = false;
RepGrinder.Debug = {}
RepGrinder.Debug.ResetAccountVariables = false
RepGrinder.Debug.ResetCharacterVariables = false

function RepGrinder:init()	
	RepGrinder:UnregisterEvent("ADDON_LOADED") 
	RepGrinder:UnregisterEvent("PLAYER_ENTERING_WORLD")
	RepGrinder:UnregisterEvent("VARIABLES_LOADED")
	
	--check if AllCharacterRepData exist and create it if it doesn't
	if (RepGrinderCharacterReps) then 
		AccountReps = RepGrinderCharacterReps
	else
		RepGrinder:ResetAccountVariables()
	end
	if (RepGrinderCharacterSettings) then 
		RGSettings = RepGrinderCharacterSettings
	else
		RepGrinder:ResetCharacterVariables()
	end
	RepGrinder:ValidateCharacterVariables()
	
	--For Debugging
	if(RepGrinder.Debug.ResetAccountVariables) then	RepGrinder:ResetAccountVariables() end
	if(RepGrinder.Debug.ResetCharacterVariables) then RepGrinder:ResetCharacterVariables() end
	
	RepGrinder:SetVisibleStatus()
	RepGrinder:SetupCharacter()
		
	for iFaction = 1, #RepGrinderFactionList do
		local faction = RepGrinderFactionList[iFaction]
		faction.standingID = 1
		faction.bottomValue = 0
		faction.topValue = 1000
		faction.earnedValue = 0
		faction.today = 0
		faction.session = 0
		faction.maxPlayerID = ""
		faction.maxStandingID = 1
		faction.maxBottom = 0
		faction.maxTop = 0 
		faction.maxEarned = 0
		faction.maxName = ""
		faction.maxClass = 1
		faction.visible = true
		faction.ezRepSort = 0
		faction.ezMaxRepSort = 0
		
		local name, description, standingID, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain = GetFactionInfoByID(faction.factionID)
		if(name) then
			faction.name = name
		end
		
		for iChar, storedCharacter in pairs(AccountReps) do
			local acctRep = storedCharacter.Reps[faction.factionID]
			if(not isNull(acctRep) and storedCharacter.ID ~= RepGrinder.PlayerID) then
				if (acctRep.standingID > faction.maxStandingID or (acctRep.standingID == faction.maxStandingID and acctRep.earnedValue > faction.maxEarned)) then
					faction.maxPlayerID = storedCharacter.ID
					faction.maxName = storedCharacter.Name
					faction.maxClass = storedCharacter.Class
					faction.maxStandingID = acctRep.standingID
					faction.maxBottom = acctRep.bottomValue
					faction.maxTop = acctRep.topValue
					faction.maxEarned = acctRep.earnedValue					
					updated = true
				end
			end
		end	
		
	end
	
	RepGrinderUI:SetupMinimapButton()
	RepGrinderUI:SetIconHideState(RGSettings.HideMinimapButton)	
	RepGrinderUI:AddSettingsElements(configFrame)
	RepGrinder:SetDetailsPosition()
	RepGrinder:SetWatchPosition()	
	RepGrinder:UpdateCharacterFactions()
	RepGrinder:UpdateFactionUI()
	
	
	RepGrinder.ReadyForRepUpdates = true;	
	RepGrinder:RegisterEvent("PLAYER_LOGOUT")	
	RepGrinder:RegisterEvent("UPDATE_FACTION")
	RepGrinder:RegisterEvent("GROUP_ROSTER_UPDATE")
	
	print("|cff8C8EFF[RepGrinder]|r: Loaded")
end

function RepGrinder:SetupStandings()
	RepGrinder.Standings={}
	RepGrinder.Standings[1] = "Unknown"
	for i = 1, 8 do
			RepGrinder.Standings[i + 1] = getglobal("FACTION_STANDING_LABEL"..i)
	end
end

function RepGrinder:ResetAccountVariables()
	AccountReps = {}
	RepGrinderCharacterReps = AccountReps
end
function RepGrinder:ValidateCharacterVariables()	
	if(isNull(RGSettings)) then RGSettings = {} end
	if(isNull(RGSettings.Watched)) then RGSettings.Watched = {} end
	if(isNull(RGSettings.VisibleStandings)) then RGSettings.VisibleStandings = { false, true, true, true, true, true, true, true, true, } end
	if(isNull(RGSettings.VisibleMaxStandings)) then RGSettings.VisibleMaxStandings = { false, true, true, true, true, true, true, true, true, } end
	if(isNull(RGSettings.HideOtherFaction)) then RGSettings.HideOtherFaction = true end
	if(isNull(RGSettings.HideWhenNotHighest)) then RGSettings.HideWhenNotHighest = false end
	if(isNull(RGSettings.FactionTodayDate)) then RGSettings.FactionTodayDate = Util:GetDate() end
	if(isNull(RGSettings.FactionToday)) then RGSettings.FactionToday = { } end
	if(isNull(RGSettings.FactionSession)) then RGSettings.FactionSession = { } end
	if(isNull(RGSettings.GainType)) then RGSettings.GainType = 1 end
	if(isNull(RGSettings.IsHidden)) then RGSettings.IsHidden = false end
	if(isNull(RGSettings.HideInParty)) then RGSettings.HideInParty = true end
	if(isNull(RGSettings.Location_Point)) then RGSettings.Location_Point = "CENTER" end
	if(isNull(RGSettings.Location_RelativePoint)) then RGSettings.Location_RelativePoint = "CENTER" end
	if(isNull(RGSettings.Location_XOffset)) then RGSettings.Location_XOffset = 0 end
	if(isNull(RGSettings.Location_YOffset)) then RGSettings.Location_YOffset = 0 end
	if(isNull(RGSettings.Location_Height)) then RGSettings.Location_Height = 400 end
	if(isNull(RGSettings.WLocation_Point)) then RGSettings.WLocation_Point = "TOPLEFT" end
	if(isNull(RGSettings.WLocation_RelativePoint)) then RGSettings.WLocation_RelativePoint = "TOPLEFT" end
	if(isNull(RGSettings.WLocation_XOffset)) then RGSettings.WLocation_XOffset = 10 end
	if(isNull(RGSettings.WLocation_YOffset)) then RGSettings.WLocation_YOffset = -100 end
	if(isNull(RGSettings.SortSettings)) then RGSettings.SortSettings = {} end
	--RGSettings.SortSettings.SortColumn = nil
	if(isNull(RGSettings.SortSettings.SortAsc)) then RGSettings.SortSettings.SortAsc = true end
	if(isNull(RGSettings.HideMinimapButton)) then RGSettings.HideMinimapButton = false end
	if(isNull(RGSettings.DarkerBars)) then RGSettings.DarkerBars = false end
	RepGrinderCharacterSettings = RGSettings
end
function RepGrinder:ResetCharacterVariables()	 
	RGSettings = {}
	RepGrinder:ValidateCharacterVariables()		
end

function RepGrinder:WatchPositionChanged()
	point, relativeTo, relativePoint, xOfs, yOfs = RepGrinder.WatchFrame:GetPoint()	
	RGSettings.WLocation_Point = point
	RGSettings.WLocation_RelativePoint = relativePoint
	RGSettings.WLocation_XOffset = xOfs
	RGSettings.WLocation_YOffset = yOfs
	RepGrinder:SaveSettings()
end

function RepGrinder:SetWatchPosition()
	RepGrinder.WatchFrame:SetPoint(RGSettings.WLocation_Point, UIParent, RGSettings.WLocation_RelativePoint, RGSettings.WLocation_XOffset, RGSettings.WLocation_YOffset)	
end

function RepGrinder:DetailsPositionChanged()
	point, relativeTo, relativePoint, xOfs, yOfs = RepGrinder.DetailFrame:GetPoint()
	x, y = RepGrinder.DetailFrame:GetSize()
	RGSettings.Location_Point = point
	RGSettings.Location_RelativePoint = relativePoint
	RGSettings.Location_XOffset = xOfs
	RGSettings.Location_YOffset = yOfs
	RGSettings.Location_Height = y	
	RepGrinder:SaveSettings()
end

function RepGrinder:SetDetailsPosition()
	RepGrinder.DetailFrame:SetPoint(RGSettings.Location_Point, UIParent, RGSettings.Location_RelativePoint, RGSettings.Location_XOffset, RGSettings.Location_YOffset)
	RepGrinder.DetailFrame:SetHeight(RGSettings.Location_Height)
end

function RepGrinder:SetupCharacter()
	RepGrinder.Character = {}		
	RepGrinder.Character.ID = RepGrinder.PlayerID
	RepGrinder.Character.Reps = {}
	
	local localizedClass, englishClass, localizedRace, englishRace, sex, name, realm = GetPlayerInfoByGUID(RepGrinder.PlayerID)		
	RepGrinder.Character.Name = name
	RepGrinder.Character.Realm = realm
	RepGrinder.Character.Class = englishClass
	RepGrinder.Character.Race = localizedRace
	
	local englishFaction, localizedFaction = UnitFactionGroup("player")
	if(englishFaction == "Alliance") then
		RepGrinder.Character.IsAlliance = true
	else
		RepGrinder.Character.IsAlliance = false
	end
	AccountReps[RepGrinder.Character.ID] = RepGrinder.Character	
end


function RepGrinder:UpdateCharacterFactions()
	for iFaction = 1, #RepGrinderFactionList do
		local faction = RepGrinderFactionList[iFaction]
		local name, description, standingID, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain = GetFactionInfoByID(faction.factionID)
		if(isNull(factionID) or isNull(name) or isNull(standingID) or isNull(bottomValue) or isNull(topValue) or isNull(earnedValue) or standingID == 0) then 
		else			
			RepGrinder.Character.Reps[faction.factionID] = { standingID = standingID + 1, bottomValue = bottomValue, topValue = topValue, earnedValue = earnedValue }			
		end
	end	
	RepGrinderCharacterReps = AccountReps
end

function RepGrinder:UpdateFactionUI()
	local exaltedCounter = 0
	local repGainUpdated = false
	if(RepGrinder.ResetSession) then
		RepGrinder.ResetSession = false
		RGSettings.FactionSession = { }
	end
	if(RGSettings.FactionTodayDate) then
		if(RGSettings.FactionTodayDate ~= Util:GetDate()) then			
			RGSettings.FactionToday = { }
			RGSettings.FactionTodayDate = Util:GetDate()
		end
	else 
		RGSettings.FactionToday = { }
		RGSettings.FactionTodayDate = Util:GetDate()
	end
	for iFaction = 1, #RepGrinderFactionList do
		local faction = RepGrinderFactionList[iFaction]				
		local charFaction = RepGrinder.Character.Reps[faction.factionID]	
		
		local updated = false
		if(charFaction) then					
			if(faction.standingID ~= charFaction.standingID or faction.bottomValue ~= charFaction.bottomValue or faction.topValue ~= charFaction.topValue or faction.earnedValue ~= charFaction.earnedValue) then
				repGainUpdated = RepGrinder:UpdateRepGain(faction.factionID, faction.standingID, faction.earnedValue, charFaction.earnedValue)
				faction.standingID = charFaction.standingID
				faction.bottomValue = charFaction.bottomValue
				faction.topValue = charFaction.topValue
				faction.earnedValue = charFaction.earnedValue
				updated = true
			end
			
			if (charFaction.standingID > faction.maxStandingID or (charFaction.standingID == faction.maxStandingID and charFaction.earnedValue >= faction.maxEarned)) then				
				faction.maxPlayerID = RepGrinder.Character.ID
				faction.maxName = RepGrinder.Character.Name
				faction.maxClass = RepGrinder.Character.Class
				faction.maxStandingID = charFaction.standingID
				faction.maxBottom = charFaction.bottomValue
				faction.maxTop = charFaction.topValue
				faction.maxEarned = charFaction.earnedValue
				
				updated = true
			end
		end
		
		
		RepGrinderUI:UpdateRepBar(RepGrinder.DetailFrame.Reps[faction.factionID].CharRepBar, faction.bottomValue, faction.topValue, faction.earnedValue, faction.standingID , "", 0)
		RepGrinderUI:UpdateRepBar(RepGrinder.DetailFrame.Reps[faction.factionID].MaxRepBar, faction.maxBottom, faction.maxTop, faction.maxEarned, faction.maxStandingID, faction.maxName, faction.maxClass)
		if(RGSettings.GainType == 1) then
			RepGrinder.DetailFrame.Reps[faction.factionID].Gained:SetText((Util:GetValue(RGSettings.FactionToday[factionID]) == 0) and "" or ("+ " .. Util:GetValue(RGSettings.FactionToday[factionID])))
		else
			RepGrinder.DetailFrame.Reps[faction.factionID].Gained:SetText((Util:GetValue(RGSettings.FactionSession[factionID]) == 0) and "" or ("+ " .. Util:GetValue(RGSettings.FactionSession[factionID])))
		end		
		
		if(isNull(faction.standingID) or isNull(faction.earnedValue) or isNull(faction.bottomValue) or isNull(faction.topValue) or faction.standingID <= 1) then			
			faction.ezRepSort = 0			
		else
			if (faction.standingID == 9) then
				faction.ezRepSort = (1000000 * faction.standingID)
			else
				faction.ezRepSort = (1000000 * faction.standingID) + (faction.earnedValue - faction.bottomValue) / (faction.topValue - faction.bottomValue)
			end
		end
		if(isNull(faction.maxStandingID) or isNull(faction.maxEarned) or isNull(faction.maxBottom) or isNull(faction.maxTop) or faction.standingID <= 1) then			
			faction.ezMaxRepSort = 0			
		else
			if (faction.maxStandingID == 9) then
				faction.ezMaxRepSort = (1000000 * faction.maxStandingID)
			else
				faction.ezMaxRepSort = (1000000 * faction.maxStandingID) + (faction.maxEarned - faction.maxBottom) / (faction.maxTop - faction.maxBottom)
			end
		end
		
		
		RepGrinder:SetFactionVisibility(faction)	
		if(faction.maxStandingID == 9) then
			exaltedCounter = exaltedCounter + 1
		end
	end
	if (repGainUpdated) then
		RepGrinder:SaveSettings()
	end
		
	RepGrinder:PerformSort()
	RepGrinderUI:UpdateDetailsGrid()
	RepGrinder:UpdateWatched()
	RepGrinder:UpdateExaltedCounter(exaltedCounter)
end

function RepGrinder:UpdateRepGain(factionID, oldStandingID, oldEarnedValue, newEarnedValue)
	if(oldStandingID <= 1) then 
		return false 
	else		
		local dif = newEarnedValue - oldEarnedValue	
		RGSettings.FactionToday[factionID] = Util:GetValue(RGSettings.FactionToday[factionID]) + dif
		RGSettings.FactionSession[factionID] = Util:GetValue(RGSettings.FactionSession[factionID]) + dif
		return true
	end
end

function RepGrinder:SetFactionVisibility(faction)
	if (RGSettings.Watched[faction.factionID]) then
		faction.visible = true
	elseif (not RGSettings.VisibleStandings[faction.standingID]) then
		faction.visible = false
	elseif (not RGSettings.VisibleMaxStandings[faction.maxStandingID]) then
		faction.visible = false
	elseif (RGSettings.HideWhenNotHighest and RepGrinder.Character.Name ~= faction.maxName) then
		faction.visible = false
	elseif (RGSettings.HideOtherFaction and RepGrinder.Character.IsAlliance and not faction.isAlliance) then
		faction.visible = false
	elseif (RGSettings.HideOtherFaction and not RepGrinder.Character.IsAlliance and not faction.isHorde) then
		faction.visible = false	
	else
		faction.visible = true			
	end		
end

function RepGrinder:SaveSettings()
	RepGrinderCharacterSettings = RGSettings
end

function RepGrinder:UpdateExaltedCounter(exaltedReps)
	RepGrinder.DetailFrame.title:SetText("RepGrinder ( " .. exaltedReps .. " / " .. #RepGrinderFactionList .. " )")
end

function RepGrinder:ToggleWatched(fid)
	if(RGSettings.Watched[fid]) then
		RGSettings.Watched[fid] = false
	else
		RGSettings.Watched[fid] = true
	end	
	RepGrinder:SaveSettings()
	RepGrinder:UpdateWatched()
end

function RepGrinder:UpdateWatched()
	local counter = 1
	local watchedItems = {}
	for iFaction = 1, #RepGrinderFactionList do
		local faction = RepGrinderFactionList[iFaction]
		if(RGSettings.Watched[faction.factionID]) then			
			RepGrinder.DetailFrame.Reps[faction.factionID].Favorite:SetTexCoord(0,0.5,0, 0.5)	
			watchedItems[counter] = faction
			counter = counter + 1
		else	
			RepGrinder.DetailFrame.Reps[faction.factionID].Favorite:SetTexCoord(0,0.5,0.5,1)		
		end
	end
	RepGrinderUI:SetWatchedItems(watchedItems)
end

function RepGrinder:SetVisibleStatus()
	local isInPartyOrRaid = (GetNumGroupMembers() ~= 0)
	if (RepGrinder.WatchFrame) then
		if(RGSettings.IsHidden or (RGSettings.HideInParty and isInPartyOrRaid)) then
			RepGrinder.WatchFrame:Hide()
		else
			RepGrinder.WatchFrame:Show()
		end
	end
end

function RepGrinder:SortItems(colNumber)
	if(RGSettings.SortSettings.SortColumn) then
		if(RGSettings.SortSettings.SortColumn == colNumber) then
			if(RGSettings.SortSettings.SortAsc) then					
				RGSettings.SortSettings.SortAsc = false
			else
				RGSettings.SortSettings.SortColumn = nil					
			end
		else
			RGSettings.SortSettings.SortColumn = colNumber
			RGSettings.SortSettings.SortAsc = true
		end		
	else
		RGSettings.SortSettings.SortColumn = colNumber
		RGSettings.SortSettings.SortAsc = true
	end	
	RepGrinder:SaveSettings()
	RepGrinder:PerformSort()
	RepGrinderUI:UpdateDetailsGrid()
	RepGrinder:UpdateWatched()
end

function RepGrinder:PerformSort()
	if (RGSettings.SortSettings.SortColumn) then
		if(RGSettings.SortSettings.SortColumn == 2) then	
			table.sort(RepGrinderFactionList, function(a,b) return RepGrinder:predSorterFaction(a, b, RGSettings.SortSettings.SortAsc) end)				
		elseif(RGSettings.SortSettings.SortColumn == 3) then			
			table.sort(RepGrinderFactionList, function(a,b) return RepGrinder:predSorterRep(a, b, RGSettings.SortSettings.SortAsc) end)	
		elseif(RGSettings.SortSettings.SortColumn == 4) then		
			table.sort(RepGrinderFactionList, function(a,b) return RepGrinder:predSorterMaxRep(a, b, RGSettings.SortSettings.SortAsc) end)
		end
	else
		table.sort(RepGrinderFactionList, function(a,b) return RepGrinder:predSorterFaction(a, b, true) end)		
	end
end

function RepGrinder:predSorterFaction(a, b, isAsc)	
	if(isAsc) then
		return a.name < b.name
	else
		return a.name > b.name
	end	
end

function RepGrinder:predSorterRep(a, b, isAsc)	
	if (not isAsc) then		
		if (a.ezRepSort ~= b.ezRepSort) then
			return a.ezRepSort < b.ezRepSort
		else					
			return a.name < b.name
		end	
	else
		if (a.ezRepSort ~= b.ezRepSort) then
			return a.ezRepSort > b.ezRepSort
		else					
			return a.name < b.name
		end	
	end	
end
	

function RepGrinder:predSorterMaxRep(a, b, isAsc)	
	if (not isAsc) then		
		if (a.ezMaxRepSort ~= b.ezMaxRepSort) then
			return a.ezMaxRepSort < b.ezMaxRepSort
		else					
			return a.name < b.name
		end	
	else
		if (a.ezMaxRepSort ~= b.ezMaxRepSort) then
			return a.ezMaxRepSort > b.ezMaxRepSort
		else					
			return a.name < b.name
		end	
	end	
end



function RepGrinder:FactionRow_Clicked(fid)
	
end


function isNull(obj)
	if(obj) then return false end
	return true
end

Util = { }
function Util:GetDate()	local d = C_DateAndTime.GetCurrentCalendarTime() return (d.year*10000)+(d.month*100)+d.monthDay end
function Util:GetValue(numObject)	if(numObject) then return numObject else return 0 end end
function Util:ternary ( cond , trueValue , falseValue)
    if cond then return trueValue else return falseValue end
end

RepGrinder:SetupStandings()
RepGrinderUI:CreateWatchFrame(RepGrinder)
RepGrinderUI:CreateDetailFrame(RepGrinder)

