local RepGrinderAddon = ...
local addonLoaded = false
local savedDataLoaded = false;
local playerEnteredWorld = false;

function RepGrinder:ADDON_LOADED(AddOn)		
	if (AddOn ~= "RepGrinder") then return end -- cancels loaded events if not from RepGrinder addon
	addonLoaded = true
	if (not savedDataLoaded or not addonLoaded or not playerEnteredWorld) then return end
	RepGrinder:init()
end

function RepGrinder:VARIABLES_LOADED(AddOn)
	savedDataLoaded = true
	if (not savedDataLoaded or not addonLoaded or not playerEnteredWorld) then return end
	RepGrinder:init()
end

function RepGrinder:PLAYER_ENTERING_WORLD(AddOn)
	local repTab = _G["CharacterFrameTab2"]
	repTab:SetScript("OnClick", function (self) RepGrinderUI:ToggleDetailWindow(true) ToggleCharacter("ReputationFrame") end)
		
	key1, key2 = GetBindingKey("TOGGLECHARACTER2")
	if (key1) then
		SetOverrideBinding(RepGrinder, true, key1, "REPGRINDER_TOGGLE_UI");	
	end
	if (key2) then
		SetOverrideBinding(RepGrinder, true, key2, "REPGRINDER_TOGGLE_UI");	
	end
	playerEnteredWorld = true
	if (not savedDataLoaded or not addonLoaded or not playerEnteredWorld) then return end
	RepGrinder:init()
end

function RepGrinder:PLAYER_LOGOUT(event, args)
	RepGrinder:UpdateCharacterFactions()
end

function RepGrinder:PLAYER_LOGIN(event, args)	
	RepGrinder.ResetSession  = true
end

function RepGrinder:GROUP_ROSTER_UPDATE()
	RepGrinder:SetVisibleStatus()
end


function RepGrinder:UPDATE_FACTION(event, args)	
	if(RepGrinder.ReadyForRepUpdates) then
		RepGrinder:UpdateCharacterFactions()
		RepGrinder:UpdateFactionUI()
	end
end

function RepGrinder:SAVED_VARIABLES_TOO_LARGE(event, args)	
	print("!!! RepGrinder: SAVED VARIABLES TOO LARGE !!!")
end

RepGrinder:RegisterEvent("ADDON_LOADED")
RepGrinder:RegisterEvent("VARIABLES_LOADED")
RepGrinder:RegisterEvent("PLAYER_LOGIN")
RepGrinder:RegisterEvent("PLAYER_ENTERING_WORLD")
RepGrinder:RegisterEvent("SAVED_VARIABLES_TOO_LARGE")

RepGrinder:SetScript("OnEvent", function(self, event, ...)	
	RepGrinder[event](self, ...)	
end)


SLASH_RepGrinder1 = "/RepGrinder"
SLASH_RepGrinder2 = "/RG"
SlashCmdList["RepGrinder"] = function(msg)
   RepGrinderUI:ToggleDetailWindow()
end 


