RepGrinderUI = CreateFrame("Frame")
RepGrinderUI.RepBarWidth = 140
RepGrinderUI.ExpansionLineHeight = 24
RepGrinderUI.RepLineHeight = 25
RepGrinderUI.RepLineSpace = 3
RepGrinderUI.DefaultFont = [[Interface\AddOns\RepGrinder\SWANSE_B.TTF]]
RepGrinderUI.SettingsWidth = 240
RepGrinderUI.DetailWindowOpen = false
RepGrinderUI.SettingsOpen = false
RepGrinderUI.ColumnWidths = { 50, 160, RepGrinderUI.RepBarWidth+10, RepGrinderUI.RepBarWidth+10, 70 }
RepGrinderUI.DetailsWidth = RepGrinderUI.ColumnWidths[1]+RepGrinderUI.ColumnWidths[2]+RepGrinderUI.ColumnWidths[3]+RepGrinderUI.ColumnWidths[4]+RepGrinderUI.ColumnWidths[5] + 33
RepGrinderUI.WatchedColumnWidths = { 160, RepGrinderUI.RepBarWidth+10, 70 }
RepGrinderUI.WatchedFrameCount = 0
RepGrinderUI.WatchedFrames = { }


local Template_UI_Panel = "UIPanelDialogTemplate"
local Template_Button = "UIGoldBorderButtonTemplate"
local Template_ScrollArea = "UIPanelScrollFrameTemplate"
local Template_Small_Button_Border = "251965"

function RepGrinderUI:CreateWatchFrame(RepGrinder) 	
	RepGrinder.WatchFrame = CreateFrame("Frame", "RepGrinder_WatchFrame", UIParent)
	RepGrinder.WatchFrame:SetFrameStrata("MEDIUM")
	RepGrinder.WatchFrame:SetSize(RepGrinderUI.ColumnWidths[1]+RepGrinderUI.ColumnWidths[2]+RepGrinderUI.ColumnWidths[3]+10, 40)
	RepGrinder.WatchFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	RepGrinder.WatchFrame:SetMovable(false)
	RepGrinder.WatchFrame:EnableMouse(false)
	RepGrinder.WatchFrame:SetClampedToScreen(true)		
	RepGrinder.WatchFrame:RegisterForDrag("LeftButton")
	RepGrinder.WatchFrame:SetScript("OnDragStart", function (self) self:StartMoving() end)
	RepGrinder.WatchFrame:SetScript("OnDragStop", function (self) self:StopMovingOrSizing() RepGrinder:WatchPositionChanged() end)	
	
	local title = RepGrinder.WatchFrame:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
	title:SetFont(RepGrinderUI.DefaultFont, 19, "THINOUTLINE")
	title:SetPoint("TOP", RepGrinder.WatchFrame, "TOP", 0, -10)
	title:SetTextColor(0.95,0.95,0.95,.7)	
	title:SetText("RepGrider Watch Window")
	RepGrinder.WatchFrame.title = title
	
	RepGrinder.WatchFrame.texture = RepGrinder.WatchFrame:CreateTexture(nil, "BACKGROUND")
	RepGrinder.WatchFrame.texture:SetAllPoints()
	RepGrinder.WatchFrame.texture:SetColorTexture(0.7,0.0,0.0,0.4)
	RepGrinder.WatchFrame.title:Hide()
	RepGrinder.WatchFrame.texture:Hide()
end

function RepGrinderUI:SetWatchedItems(items) 
	RepGrinder.WatchFrame:SetHeight((#items * (RepGrinderUI.RepLineHeight + RepGrinderUI.RepLineSpace)) + 40)
	while (RepGrinderUI.WatchedFrameCount < #items) do	
		RepGrinderUI.WatchedFrameCount = RepGrinderUI.WatchedFrameCount + 1
		RepGrinderUI.WatchedFrames[RepGrinderUI.WatchedFrameCount] = { }
		local left = 0
		local top = 0 - (((RepGrinderUI.WatchedFrameCount - 1) * (RepGrinderUI.RepLineHeight + RepGrinderUI.RepLineSpace)) + 40)
		local row = CreateFrame("Button", nil, RepGrinder.WatchFrame)						
		row:SetPoint("TOPLEFT", RepGrinder.WatchFrame, "TOPLEFT", 5, top)
		row:SetPoint("TOPRIGHT", RepGrinder.WatchFrame, "TOPRIGHT", -5, top)	
		row:SetHeight(RepGrinderUI.RepLineHeight)
		row:EnableMouse(false)
		RepGrinderUI.WatchedFrames[RepGrinderUI.WatchedFrameCount].Row = row
		
		local repLabel = row:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
		repLabel:SetFont(RepGrinderUI.DefaultFont, 13, "THINOUTLINE")
		repLabel:SetPoint("TOPLEFT", row, "TOPLEFT", left, -7)
		repLabel:SetTextColor(0.95,0.95,0.95,1)	
		RepGrinderUI.WatchedFrames[RepGrinderUI.WatchedFrameCount].FactionName = repLabel
		left = left + RepGrinderUI.WatchedColumnWidths[1]

		RepGrinderUI.WatchedFrames[RepGrinderUI.WatchedFrameCount].CharRepBar = RepGrinderUI:CreateRepBar(row, left, false);
		left = left + RepGrinderUI.WatchedColumnWidths[2]
		
		local expGained = row:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
		expGained:SetFont(RepGrinderUI.DefaultFont, 13)
		expGained:SetPoint("RIGHT", row, "RIGHT", 0, 0)
		expGained:SetTextColor(Color:FromHex("43FF40"))
		RepGrinderUI.WatchedFrames[RepGrinderUI.WatchedFrameCount].Gained = expGained
	end
	for i = 1, #items do
		local faction = items[i]
		local row = RepGrinderUI.WatchedFrames[i]
		row.Row:Show()
		row.FactionName:SetText(faction.name)
		RepGrinderUI:UpdateRepBar(row.CharRepBar, faction.bottomValue, faction.topValue, faction.earnedValue, faction.standingID , "", 0)
		if(RGSettings.GainType == 1) then
			if(isNull(RGSettings.FactionToday[faction.factionID]) or RGSettings.FactionToday[faction.factionID] == 0) then
				row.Gained:SetText("")
			else
				row.Gained:SetText("+ " .. RGSettings.FactionToday[faction.factionID])
			end
		else
			if(isNull(RGSettings.FactionSession[faction.factionID]) or RGSettings.FactionSession[faction.factionID] == 0) then
				row.Gained:SetText("")
			else
				row.Gained:SetText("+ " .. RGSettings.FactionSession[faction.factionID])
			end
		end		
	end
	if (#items < RepGrinderUI.WatchedFrameCount) then
		for i = #items + 1, RepGrinderUI.WatchedFrameCount do
			RepGrinderUI.WatchedFrames[i].Row:Hide()
		end
	end
end


function RepGrinderUI:CreateDetailFrame(RepGrinder)
	RepGrinder.DetailFrame = CreateFrame("Frame", "RepGrinder_Frame", UIParent)
	RepGrinder.DetailFrame:SetSize(RepGrinderUI.DetailsWidth, 400)
	RepGrinder.DetailFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	RepGrinder.DetailFrame:SetMovable(true)	
	RepGrinder.DetailFrame:SetResizable(true)
	RepGrinder.DetailFrame:SetClampedToScreen(true)	
	RepGrinder.DetailFrame.isResizing = false
	RepGrinder.DetailFrame:SetScript("OnShow", function() RepGrinderUI:SetWatchFrameState(true) RepGrinderUI.DetailWindowOpen = true end)
	RepGrinder.DetailFrame:SetScript("OnHide", function() RepGrinderUI:SetWatchFrameState(false) RepGrinderUI.DetailWindowOpen = false end)
	
	_G["RepGrinderDetailWindow"] = RepGrinder.DetailFrame
	tinsert(UISpecialFrames, "RepGrinderDetailWindow")
	
	--Add Background To Window
	RepGrinder.DetailFrame.texture = RepGrinder.DetailFrame:CreateTexture(nil, "BACKGROUND")
	RepGrinder.DetailFrame.texture:SetAllPoints()
	RepGrinder.DetailFrame.texture:SetColorTexture(0.0,0.0,0.0,0.4)
	
	-- Title Bar
	RepGrinder.WindowTitleBar = CreateFrame("Button", "RepGrinder_TitleBar", RepGrinder.DetailFrame)
	RepGrinder.WindowTitleBar:SetHeight(23)
	RepGrinder.WindowTitleBar:SetPoint("TOPLEFT", RepGrinder.DetailFrame, "TOPLEFT", 0, 0)
	RepGrinder.WindowTitleBar:SetPoint("TOPRIGHT", RepGrinder.DetailFrame, "TOPRIGHT", 0, 0)	
	
	RepGrinder.WindowTitleBar:EnableMouse(true)	
	RepGrinder.WindowTitleBar:RegisterForDrag("LeftButton")
	RepGrinder.WindowTitleBar:SetScript("OnDragStart", function (self) RepGrinder.DetailFrame:StartMoving() end)
	RepGrinder.WindowTitleBar:SetScript("OnDragStop", function (self) RepGrinder.DetailFrame:StopMovingOrSizing() RepGrinder:DetailsPositionChanged() end)	
	
	local titleTexture = RepGrinder.WindowTitleBar:CreateTexture(nil, "ARTWORK")
	titleTexture:SetAllPoints()
	titleTexture:SetColorTexture(0.0,0.0,0.0,0.3)
	
	-- Add Header Text
	RepGrinder.DetailFrame.title = RepGrinder.WindowTitleBar:CreateFontString("Window_Header_Texture", "OVERLAY")
	RepGrinder.DetailFrame.title:SetFont(RepGrinderUI.DefaultFont, 13, "THINOUTLINE")
	RepGrinder.DetailFrame.title:SetPoint("TOPLEFT", RepGrinder.WindowTitleBar, "TOPLEFT", 10, -6)
	RepGrinder.DetailFrame.title:SetText("Rep Grinder")
	RepGrinder.DetailFrame.title:SetTextColor(0.8,0.8,0.8,0.9)
		
	local configButton = CreateFrame("Button", nil, RepGrinder.WindowTitleBar)						
	configButton:SetPoint("TOPRIGHT", RepGrinder.WindowTitleBar, "TOPRIGHT", 4, -2)	
	configButton:SetSize(25,25)
	configButton:SetScript("OnClick", function(self, arg1) RepGrinderUI:ToggleSettings() end)
	local configBorderTexture = configButton:CreateTexture(nil, "ARTWORK")
	configBorderTexture:SetAllPoints()
	configBorderTexture:SetTexture(Template_Small_Button_Border, true)
	configBorderTexture:SetTexCoord(0,1,0,1)
	local configGearTexture = configButton:CreateTexture(nil, "OVERLAY")
	configGearTexture:SetPoint("TOPLEFT", configButton, "TOPLEFT", 3, -3)	
	configGearTexture:SetPoint("BOTTOMRIGHT", configButton, "BOTTOMRIGHT", -8, 8)	
	configGearTexture:SetTexture(311225, true)
	configGearTexture:SetTexCoord(0,.5,0,.5)
	
	-- Add Rep Headers
	RepGrinder.RepHeaders = CreateFrame("Frame", "RepGrinder_Frame", RepGrinder.DetailFrame)
	RepGrinder.RepHeaders:SetHeight(20)
	RepGrinder.RepHeaders:SetPoint("TOPLEFT", RepGrinder.DetailFrame, "TOPLEFT", 0, -27)
	RepGrinder.RepHeaders:SetPoint("TOPRIGHT", RepGrinder.DetailFrame, "TOPRIGHT", 0, -27)
		
	-- Add Scroll Area
	RepGrinder.DetailFrame.scrollArea = CreateFrame("ScrollFrame", nil, RepGrinder.DetailFrame, Template_ScrollArea)
	RepGrinder.DetailFrame.scrollArea:SetPoint("TOPLEFT", RepGrinder.DetailFrame, "TOPLEFT", 5, -55)
	RepGrinder.DetailFrame.scrollArea:SetPoint("BOTTOMRIGHT", RepGrinder.DetailFrame, "BOTTOMRIGHT", -25, 45)
	
	local scrollableHeight = (#RepGrinderFactionList * (RepGrinderUI.RepLineHeight + RepGrinderUI.RepLineSpace)) + (#Expansions * (RepGrinderUI.ExpansionLineHeight + RepGrinderUI.RepLineSpace))
	-- Add Rep Container
	RepGrinder.RepContainer = CreateFrame("Frame", "RepGrinder_Frame", RepGrinder.DetailFrame.scrollArea);
	RepGrinder.RepContainer:SetPoint("TOPLEFT", RepGrinder.DetailFrame.scrollArea, "TOPLEFT", 0, 0)
	RepGrinder.RepContainer:SetHeight(scrollableHeight)
	RepGrinder.RepContainer:SetWidth(2000)
		
	RepGrinder.RepHeaders.Headers = { }
	RepGrinderUI:CreateHeader(RepGrinder.RepHeaders, 1, "Watch", false)
	RepGrinderUI:CreateHeader(RepGrinder.RepHeaders, 2, "Faction", true)
	RepGrinderUI:CreateHeader(RepGrinder.RepHeaders, 3, "Character Rep", true)
	RepGrinderUI:CreateHeader(RepGrinder.RepHeaders, 4, "Max Faction Rep", true)
	RepGrinderUI:CreateHeader(RepGrinder.RepHeaders, 5, "Gained", false)
	
	RepGrinder.DetailFrame.scrollArea:SetScrollChild(RepGrinder.RepContainer)
	RepGrinder.DetailFrame.scrollArea:UpdateScrollChildRect()
	
	table.sort(RepGrinderFactionList, function(a,b) return a.name < b.name end)
	RepGrinder.DetailFrame.Expansions = {}
	RepGrinder.DetailFrame.Reps = {}
	local top = 0;
	for iExp = 1, #Expansions do
		local expansion = Expansions[(#Expansions + 1 ) - iExp]
		local expNum = expansion.ExpansionNumber
		local name, description, standingID, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain = GetFactionInfoByID(expansion.FactionID)
		if(name) then
			expansion.FullName = name
		end
		RepGrinderUI:CreateExpansionHeader(RepGrinder, expansion, 0 - top)
		top = top + RepGrinderUI.ExpansionLineHeight + RepGrinderUI.RepLineSpace
		
		for iRep = 1, #RepGrinderFactionList do
			if(expNum == RepGrinderFactionList[iRep].expansion) then
				RepGrinderUI:CreateFactionLine(RepGrinder, RepGrinderFactionList[iRep], 0 - top)
				top = top + RepGrinderUI.RepLineHeight + RepGrinderUI.RepLineSpace
			end
		end
	end	
		
	RepGrinder.DetailFrame.ResizeBar = CreateFrame("Button", nil, RepGrinder.DetailFrame)	
	RepGrinder.DetailFrame.ResizeBar:SetHeight(7)
	RepGrinder.DetailFrame.ResizeBar:SetPoint("BOTTOMLEFT", RepGrinder.DetailFrame, "BOTTOMLEFT", 0, 0)
	RepGrinder.DetailFrame.ResizeBar:SetPoint("BOTTOMRIGHT", RepGrinder.DetailFrame, "BOTTOMRIGHT", 0, 0)
	RepGrinder.DetailFrame.ResizeBar:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
	RepGrinder.DetailFrame.ResizeBar:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
	RepGrinder.DetailFrame.ResizeBar:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")	 
	RepGrinder.DetailFrame.ResizeBar:SetScript("OnMouseDown", function(self, button) RepGrinder.DetailFrame:StartSizing("BOTTOM") RepGrinder.DetailFrame:SetUserPlaced(true) end) 
	RepGrinder.DetailFrame.ResizeBar:SetScript("OnMouseUp", function(self, button) RepGrinder.DetailFrame:StopMovingOrSizing() RepGrinder:DetailsPositionChanged() end)
	RepGrinder.DetailFrame.ResizeBar.texture = RepGrinder.DetailFrame.ResizeBar:CreateTexture(nil, "ARTWORK")
	RepGrinder.DetailFrame.ResizeBar.texture:SetAllPoints()
	RepGrinder.DetailFrame.ResizeBar.texture:SetColorTexture(0.0,0.0,0.0,0.4)
	RepGrinder.DetailFrame.ResizeBar.htexture = RepGrinder.DetailFrame.ResizeBar:CreateTexture(nil, "ARTWORK")
	RepGrinder.DetailFrame.ResizeBar.htexture:SetAllPoints()
	RepGrinder.DetailFrame.ResizeBar.htexture:SetColorTexture(0.6,0.6,0.0,0.6)
	RepGrinder.DetailFrame.ResizeBar.ptexture = RepGrinder.DetailFrame.ResizeBar:CreateTexture(nil, "ARTWORK")
	RepGrinder.DetailFrame.ResizeBar.ptexture:SetAllPoints()
	RepGrinder.DetailFrame.ResizeBar.ptexture:SetColorTexture(0.8,0.8,0.8,0.8)
	RepGrinder.DetailFrame.ResizeBar:SetNormalTexture(RepGrinder.DetailFrame.ResizeBar.texture)
	RepGrinder.DetailFrame.ResizeBar:SetHighlightTexture(RepGrinder.DetailFrame.ResizeBar.htexture)
	RepGrinder.DetailFrame.ResizeBar:SetPushedTexture(RepGrinder.DetailFrame.ResizeBar.ptexture)
	
	settingsFrame = CreateFrame("Frame", "RepGrinder_Frame", RepGrinder.DetailFrame)
	settingsFrame:SetPoint("TOPRIGHT", RepGrinder.DetailFrame, "TOPRIGHT", -5, -28)
	settingsFrame:SetPoint("BOTTOMRIGHT", RepGrinder.DetailFrame, "BOTTOMRIGHT", -5, 12)
	settingsFrame:SetWidth(RepGrinderUI.SettingsWidth-10)
	settingsFrame:Hide()
	local settingsbg = settingsFrame:CreateTexture(nil, "BACKGROUND")
	settingsbg:SetAllPoints()
	settingsbg:SetColorTexture(0.0,0.0,0.0,0.3)		
	RepGrinder.DetailFrame.Settings = settingsFrame
		
	closeButton = CreateFrame("Button", nil, RepGrinder.DetailFrame)	
	closeButton:SetPoint("BOTTOM", RepGrinder.DetailFrame, "BOTTOM", 0, 12)
	closeButton:SetSize(120, 25)	
	closeButton:SetScript("OnClick", function(self, arg1) RepGrinderUI:ToggleDetailWindow() end)
	local closeButtonbg = closeButton:CreateTexture(nil, "BACKGROUND")
	closeButtonbg:SetAllPoints()
	closeButtonbg:SetColorTexture(0.5,0.5,0.9,0.9)	
	closeButton:SetNormalTexture(closeButtonbg)
	local closeButtonbgh = closeButton:CreateTexture(nil, "BACKGROUND")
	closeButtonbgh:SetAllPoints()
	closeButtonbgh:SetColorTexture(0.5,0.5,0.5,0.9)	
	closeButton:SetHighlightTexture(closeButtonbgh)
	local closeButtonText = closeButton:CreateFontString("Window_Header_Texture", "OVERLAY")
	closeButtonText:SetFont(RepGrinderUI.DefaultFont, 13, "THINOUTLINE")
	closeButtonText:SetAllPoints()
	closeButtonText:SetText("Close")
	closeButtonText:SetTextColor(0.8,0.8,0.8,1)
	
	
	RepGrinder.DetailFrame:Hide()
end

function RepGrinderUI:SetWatchFrameState(isMoveable)
	if(isMoveable) then
		RepGrinder.WatchFrame:SetMovable(true)
		RepGrinder.WatchFrame:EnableMouse(true)
		RepGrinder.WatchFrame.title:Show()
		RepGrinder.WatchFrame.texture:Show()
	else
		RepGrinder.WatchFrame:SetMovable(false)
		RepGrinder.WatchFrame:EnableMouse(false)
		RepGrinder.WatchFrame.title:Hide()
		RepGrinder.WatchFrame.texture:Hide()
	end
end

function RepGrinderUI:ToggleDetailWindow(openOnly)	
	if(openOnly) then RepGrinder.DetailFrame:Show() end
	if(not RepGrinderUI.DetailWindowOpen) then		
		RepGrinder.DetailFrame:Show()		
	else		
		RepGrinder.DetailFrame:Hide()
	end
end

function RepGrinderUI:ToggleSettings()
	RepGrinderUI.SettingsOpen = not RepGrinderUI.SettingsOpen
	if(RepGrinderUI.SettingsOpen) then
		RepGrinder.DetailFrame:SetWidth(RepGrinderUI.DetailsWidth + RepGrinderUI.SettingsWidth)
		RepGrinder.DetailFrame.Settings:Show()
		RepGrinder.DetailFrame.scrollArea:SetPoint("BOTTOMRIGHT", RepGrinder.DetailFrame, "BOTTOMRIGHT", 0 - (RepGrinderUI.SettingsWidth + 25), 45)
	else
		RepGrinder.DetailFrame:SetWidth(RepGrinderUI.DetailsWidth)
		RepGrinder.DetailFrame.Settings:Hide()
		RepGrinder.DetailFrame.scrollArea:SetPoint("BOTTOMRIGHT", RepGrinder.DetailFrame, "BOTTOMRIGHT", -25, 45)
	end	
end

function RepGrinderUI:CreateExpansionHeader(RepGrinder, expansion, top)
	local row = CreateFrame("Button", nil, RepGrinder.RepContainer)						
	row:SetPoint("TOPLEFT", RepGrinder.RepContainer, "TOPLEFT", 0, top)
	row:SetPoint("TOPRIGHT", RepGrinder.RepContainer, "TOPRIGHT", 0, top)	
	row:SetHeight(RepGrinderUI.ExpansionLineHeight)
	RepGrinder.DetailFrame.Expansions[expansion.ExpansionNumber] = row
	
	local expLabel = row:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
	expLabel:SetFont(RepGrinderUI.DefaultFont, 15)
	expLabel:SetPoint("LEFT", row, "LEFT", 5, -1)		
	expLabel:SetText(expansion.FullName)
	expLabel:SetTextColor(Color:FromHex("FED000"))	
	
	local bg = row:CreateTexture(nil, "BACKGROUND")
	bg:SetAllPoints()
	bg:SetColorTexture(0.0,0.0,0.0,0.6)
end

function RepGrinderUI:CreateFactionLine(RepGrinder, faction, top)
	local fid = faction.factionID		
	RepGrinder.DetailFrame.Reps[fid] = {}		
	local row = CreateFrame("Button", nil, RepGrinder.RepContainer)						
	row:SetPoint("TOPLEFT", RepGrinder.RepContainer, "TOPLEFT", 0, top)
	row:SetPoint("TOPRIGHT", RepGrinder.RepContainer, "TOPRIGHT", 0, top)	
	row:SetHeight(RepGrinderUI.RepLineHeight)
	RepGrinder.DetailFrame.Reps[fid].Row = row
	
	local left = 5;
	
	local star = CreateFrame("Button", nil, row)						
	star:SetPoint("TOPLEFT", row, "TOPLEFT", 5, 0)	
	star:SetPoint("BOTTOMLEFT", row, "BOTTOMLEFT", 5, 0)
	star:SetWidth(RepGrinderUI.ColumnWidths[1])		
	star:SetScript("OnClick", function(self, arg1) RepGrinder:ToggleWatched(fid) end)
	local starTexture = star:CreateTexture(nil, "OVERLAY")
	starTexture:SetPoint("CENTER", star, "CENTER", 0, 0)
	starTexture:SetSize(18,18)
	starTexture:SetTexture(838818, true)
	starTexture:SetTexCoord(0,0.5,0.5,1)
	RepGrinder.DetailFrame.Reps[fid].Favorite = starTexture
	left = left + RepGrinderUI.ColumnWidths[1]
			
	local repLabel = row:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
	repLabel:SetFont(RepGrinderUI.DefaultFont, 13, "THINOUTLINE")
	repLabel:SetPoint("TOPLEFT", row, "TOPLEFT", left, -7)		
	repLabel:SetText(faction.name)
	repLabel:SetTextColor(0.95,0.95,0.95,1)	
	left = left + RepGrinderUI.ColumnWidths[2]

	RepGrinder.DetailFrame.Reps[fid].CharRepBar = RepGrinderUI:CreateRepBar(row, left, false);
	left = left + RepGrinderUI.ColumnWidths[3]
			
	RepGrinder.DetailFrame.Reps[fid].MaxRepBar = RepGrinderUI:CreateRepBar(row, left, true);
	left = left + RepGrinderUI.ColumnWidths[4]
	RepGrinder.DetailFrame.Reps[fid].MaxRepBar:SetScript("OnEnter", function(self, event, ...)				
		RepGrinder.DetailFrame.Reps[fid].MaxRepBar.maxCharText:Hide()
		RepGrinder.DetailFrame.Reps[fid].MaxRepBar.standing:Show()
		RepGrinder.DetailFrame.Reps[fid].MaxRepBar.totals:Show()
	end)
	RepGrinder.DetailFrame.Reps[fid].MaxRepBar:SetScript("OnLeave", function(self, event, ...)
		RepGrinder.DetailFrame.Reps[fid].MaxRepBar.maxCharText:Show()
		RepGrinder.DetailFrame.Reps[fid].MaxRepBar.standing:Hide()
		RepGrinder.DetailFrame.Reps[fid].MaxRepBar.totals:Hide()
	end)
	
	local gainContainer = CreateFrame("Button", nil, row)						
	gainContainer:SetPoint("TOPLEFT", row, "TOPLEFT", left, 0)
	gainContainer:SetPoint("BOTTOMLEFT", row, "BOTTOMLEFT", left, 0)	
	gainContainer:SetWidth(RepGrinderUI.ColumnWidths[5])
	local expGained = gainContainer:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
	expGained:SetFont(RepGrinderUI.DefaultFont, 13)
	expGained:SetPoint("RIGHT", gainContainer, "RIGHT", -5 , -1)		
	expGained:SetText("")
	expGained:SetTextColor(Color:FromHex("43FF40"))
	RepGrinder.DetailFrame.Reps[fid].Gained = expGained
	
	local bg = row:CreateTexture(nil, "BACKGROUND")
	bg:SetAllPoints()
	bg:SetColorTexture(0.5,0.5,0.5,0.5)	
	row:SetHighlightTexture(bg)
	
	row:SetScript("OnClick", function(self, arg1) RepGrinder:FactionRow_Clicked(fid) end)
	
end

function RepGrinderUI:CreateHeader(parent, colNumber, text, addHeaderHighlight)
	local left = 5
	for i = 1, colNumber - 1 do
		left = left + RepGrinderUI.ColumnWidths[i]
	end
	RepGrinder.RepHeaders.Headers[colNumber] = CreateFrame("Button", "Header_Col_"..colNumber, parent);
	RepGrinder.RepHeaders.Headers[colNumber]:SetPoint("TOPLEFT", parent, "TOPLEFT", left + 2, 0)
	RepGrinder.RepHeaders.Headers[colNumber]:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", left + 2, 0)
	RepGrinder.RepHeaders.Headers[colNumber]:SetWidth(RepGrinderUI.ColumnWidths[colNumber] - 4)
	
	local headerString = RepGrinder.RepHeaders.Headers[colNumber]:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
	headerString:SetFont(RepGrinderUI.DefaultFont, 13)
	headerString:SetPoint("CENTER", RepGrinder.RepHeaders.Headers[colNumber], "CENTER", 0 -2)
	--headerString:SetPoint("TOPLEFT", RepGrinder.RepHeaders.Headers[colNumber], "TOPLEFT", 0, 0)		
	headerString:SetText(text)
	headerString:SetTextColor(0.9,0.9,0.9,0.9)
	
	local bg = RepGrinder.RepHeaders.Headers[colNumber]:CreateTexture(nil, "BACKGROUND")
	bg:SetAllPoints()
	bg:SetColorTexture(Color:FromHex("598BF6", 0.5))
	RepGrinder.RepHeaders.Headers[colNumber]:SetNormalTexture(bg)
	if (addHeaderHighlight) then
		local bgh = RepGrinder.RepHeaders.Headers[colNumber]:CreateTexture(nil, "BACKGROUND")
		bgh:SetAllPoints()
		bgh:SetColorTexture(Color:FromHex("CCCCCC", 0.5))	
		RepGrinder.RepHeaders.Headers[colNumber]:SetHighlightTexture(bgh)
	end
	if (colNumber ~= 1) then
		RepGrinder.RepHeaders.Headers[colNumber]:SetScript("OnClick", function(self, event, ...) RepGrinder:SortItems(colNumber) end)		
	end
end

function RepGrinderUI:CreateRepBar(par, x, isHover)	
	repBar = CreateFrame("Frame", nil, par)
	repBar:SetPoint("TOPLEFT", par, "TOPLEFT", x, -2)
	repBar:SetPoint("BOTTOMLEFT", par, "BOTTOMLEFT", x, 2)
	repBar:SetWidth(RepGrinderUI.RepBarWidth)
	repBar.isHover = isHover
	
	barBG = repBar:CreateTexture(nil, "BACKGROUND")	
	barBG:SetAllPoints()
	barBG:SetColorTexture(0.0,0.0,0.0,0.6)
	
	local clrs = RepColors[1];
	repBar.progress = repBar:CreateTexture(nil, "ARTWORK")
	repBar.progress:SetAllPoints()	
	repBar.progress:SetColorTexture(clrs.r,clrs.g,clrs.b,0.9)
		
	repBar.standing = repBar:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
	repBar.standing:SetFont(RepGrinderUI.DefaultFont, 11, "THIOUTLINE")
	repBar.standing:SetPoint("CENTER", repBar)
	repBar.standing:SetText(RepGrinder.Standings[1])
	repBar.standing:SetTextColor(1,1,1,1)	
	
	repBar.totals = repBar:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
	repBar.totals:SetFont(RepGrinderUI.DefaultFont, 10, "THINOUTLINE")
	repBar.totals:SetPoint("TOPRIGHT", repBar, "TOPRIGHT", -3, -5)
	repBar.totals:SetText("")
	repBar.totals:SetTextColor(1,1,1,1)
	
	if (isHover) then		
		repBar.maxCharText = repBar:CreateFontString(nil, "HIGH", "GameFontNormalSmall")
		repBar.maxCharText:SetFont(RepGrinderUI.DefaultFont, 11, "THINOUTLINE")
		repBar.maxCharText:SetAllPoints()
		repBar.maxCharText:SetText("")
		repBar.maxCharText:SetTextColor(0.9,0.9,0.9,0.9)	
		
		repBar.standing:Hide()
		repBar.totals:Hide()
	end
	return repBar
end

function RepGrinderUI:UpdateRepBar(repBar, valmin, valmax, value, standingID, name, classID)
	local difTotal = math.abs(valmax - valmin);
	local difValue = math.abs(value - valmin);
	local progress_width = (difValue/difTotal) * RepGrinderUI.RepBarWidth	
	if(standingID == 1 or standingID == 9)
	then		
		repBar.standing:SetPoint("CENTER", repBar)		
		repBar.standing:SetText(RepGrinder.Standings[standingID])
		repBar.standing:SetTextColor(1,1,1,1)	
		repBar.totals:SetText("")
		
		repBar.progress:SetAllPoints(repBar)		
	else
		repBar.standing:SetPoint("LEFT", repBar, "LEFT", 3, 0)
		repBar.standing:SetText(RepGrinder.Standings[standingID])
				
		repBar.totals:SetText(difValue .. " / " .. difTotal)
		
		repBar.progress:ClearAllPoints()
		repBar.progress:SetPoint("TOPLEFT", repBar, "TOPLEFT", 0, 0)
		repBar.progress:SetPoint("BOTTOMLEFT", repBar, "BOTTOMLEFT", 0, 0)
		repBar.progress:SetWidth(progress_width);
	end	
	local clrs = RepColors[standingID];
	if(RGSettings.DarkerBars) then
		repBar.progress:SetColorTexture(clrs.r*.6,clrs.g*.6,clrs.b*.6,0.9)
	else
		repBar.progress:SetColorTexture(clrs.r,clrs.g,clrs.b,0.9)
	end
	
	if(name ~= "") then
		local classColor = C_ClassColor.GetClassColor(classID)		
		repBar.maxCharText:SetTextColor(classColor.r, classColor.g, classColor.b, 1.0)
		repBar.maxCharText:SetText(name)
	end
end

function RepGrinderUI:UpdateDetailsGrid()	
	local top = 0;
	for iExp = 1, #Expansions do
		local expansion = Expansions[(#Expansions + 1 ) - iExp]
		local expNum = expansion.ExpansionNumber		
		local row = RepGrinder.DetailFrame.Expansions[expNum]
		row:SetPoint("TOPLEFT", RepGrinder.RepContainer, "TOPLEFT", 0, top)
		row:SetPoint("TOPRIGHT", RepGrinder.RepContainer, "TOPRIGHT", 0, top)	
		top = top - (RepGrinderUI.ExpansionLineHeight + RepGrinderUI.RepLineSpace)		
		for iRep = 1, #RepGrinderFactionList do
			if(expNum == RepGrinderFactionList[iRep].expansion) then		
				faction = RepGrinderFactionList[iRep]
				local repRow = RepGrinder.DetailFrame.Reps[faction.factionID].Row
				if (faction.visible) then
					repRow:Show()
					repRow:SetPoint("TOPLEFT", RepGrinder.RepContainer, "TOPLEFT", 0, top)
					repRow:SetPoint("TOPRIGHT", RepGrinder.RepContainer, "TOPRIGHT", 0, top)
					top = top - (RepGrinderUI.RepLineHeight + RepGrinderUI.RepLineSpace)
				else
					repRow:Hide()
				end
			end
		end
	end
	RepGrinder.RepContainer:SetHeight(0 - top)
end

function RepGrinderUI:AddSettingsElements(settingsFrame)
	local top = -5
	detaillabel = RepGrinder.DetailFrame.Settings:CreateFontString(nil, "OVERLAY")
	detaillabel:SetFont(RepGrinderUI.DefaultFont, 17)
	detaillabel:SetPoint("TOPLEFT", RepGrinder.DetailFrame.Settings, "TOPLEFT", 10, top)
	detaillabel:SetText("RepGrinder Options")
	detaillabel:SetTextColor(Color:FromHex("598BF6"))
	top = top-20
	RepGrinderUI:CreateCheckBox(RepGrinder.DetailFrame.Settings, "Hide Other Faction", 7, top, 205, "HideOtherFaction", 1, RGSettings.HideOtherFaction)	
	top = top-18
	RepGrinderUI:CreateCheckBox(RepGrinder.DetailFrame.Settings, "Hide When Not Highest", 7, top, 205, "HideWhenNotHighest", 1, RGSettings.HideWhenNotHighest)
	top = top-18
	RepGrinderUI:CreateCheckBox(RepGrinder.DetailFrame.Settings, "Hide Minimap Button", 7, top, 205, "HideMinimapButton", 1, RGSettings.HideMinimapButton)
	top = top-18
	RepGrinderUI:CreateCheckBox(RepGrinder.DetailFrame.Settings, "Darker Bars", 7, top, 205, "DarkerBars", 1, RGSettings.DarkerBars)
	top = top-25
	



	charRepLabel = RepGrinder.DetailFrame.Settings:CreateFontString(nil, "OVERLAY")
	charRepLabel:SetFont(RepGrinderUI.DefaultFont, 17)
	charRepLabel:SetPoint("TOPLEFT", RepGrinder.DetailFrame.Settings, "TOPLEFT", 10, top)
	charRepLabel:SetText("Char Rep")
	charRepLabel:SetTextColor(Color:FromHex("598BF6"))
	
	maxRepLabel = RepGrinder.DetailFrame.Settings:CreateFontString(nil, "OVERLAY")
	maxRepLabel:SetFont(RepGrinderUI.DefaultFont, 17)
	maxRepLabel:SetPoint("TOPLEFT", RepGrinder.DetailFrame.Settings, "TOPLEFT", 130, top)
	maxRepLabel:SetText("Max Rep")
	maxRepLabel:SetTextColor(Color:FromHex("598BF6"))
	top = top-20
	
	for i = 1, 9 do		
		local standingID = 10 - i
		RepGrinderUI:CreateCheckBox(RepGrinder.DetailFrame.Settings, RepGrinder.Standings[standingID], 7, top, 110, "CharRep", standingID, RGSettings.VisibleStandings[standingID])		
		RepGrinderUI:CreateCheckBox(RepGrinder.DetailFrame.Settings, RepGrinder.Standings[standingID], 127, top, 110, "MaxRep", standingID, RGSettings.VisibleMaxStandings[standingID])		
		top = top-18
	end
	top=top-7
			
	otherOptionsLabel = RepGrinder.DetailFrame.Settings:CreateFontString(nil, "OVERLAY")
	otherOptionsLabel:SetFont(RepGrinderUI.DefaultFont, 17)
	otherOptionsLabel:SetPoint("TOPLEFT", RepGrinder.DetailFrame.Settings, "TOPLEFT", 10, top)
	otherOptionsLabel:SetText("Watch Window Options")
	otherOptionsLabel:SetTextColor(Color:FromHex("598BF6"))
	top = top-20
	RepGrinderUI:CreateCheckBox(RepGrinder.DetailFrame.Settings, "Hide Watch Window", 7, top, 205, "IsHidden", 1, RGSettings.IsHidden)
	top = top-18
	RepGrinderUI:CreateCheckBox(RepGrinder.DetailFrame.Settings, "Hide When In Party", 7, top, 205, "HideInParty", 1, RGSettings.HideInParty)
	
end

function RepGrinderUI:ToggleCheckBox(cb)
	cb.IsChecked = not cb.IsChecked
	if(cb.IsChecked) then
		cb.Check:Show()
	else
		cb.Check:Hide()		
	end		
end

function RepGrinderUI:UpdateGridSettings(parmType, args, isChecked)	
	if (parmType=="CharRep") then
		RGSettings.VisibleStandings[args] = isChecked
		RepGrinder:UpdateFactionUI()
	elseif (parmType=="MaxRep") then
		RGSettings.VisibleMaxStandings[args] = isChecked
		RepGrinder:UpdateFactionUI()
	elseif (parmType=="HideOtherFaction") then
		RGSettings.HideOtherFaction = isChecked
		RepGrinder:UpdateFactionUI()	
	elseif (parmType=="HideWhenNotHighest") then
		RGSettings.HideWhenNotHighest = isChecked
		RepGrinder:UpdateFactionUI()		
	elseif (parmType=="IsHidden") then
		RGSettings.IsHidden = isChecked
		RepGrinder:SetVisibleStatus()
	elseif (parmType=="HideInParty") then
		RGSettings.HideInParty = isChecked
		RepGrinder:SetVisibleStatus()
	elseif (parmType=="HideMinimapButton") then
		RGSettings.HideMinimapButton = isChecked
		RepGrinderUI:SetIconHideState(isChecked)
	elseif (parmType=="DarkerBars") then
		RGSettings.DarkerBars = isChecked
		RepGrinder:UpdateFactionUI()
	end		
	
	RepGrinder:SaveSettings()
end

function RepGrinderUI:SetIconHideState(isHidden)	
	if(isHidden) then
		RepGrinder.MinimapButton:Hide("RepGrinder")
	else
		RepGrinder.MinimapButton:Show("RepGrinder")
	end
end


function RepGrinderUI:CreateCheckBox(parent, text, x, y, width, parmtype, args, initialState)	
	local Template_Checkbox = CreateFrame("Button", nil, parent)	
	Template_Checkbox:SetPoint("TOPLEFT", parent, "TOPLEFT", x, y )
	Template_Checkbox:SetHeight(18)
	Template_Checkbox:SetWidth(width)
	Template_Checkbox.IsChecked = initialState;
	Template_Checkbox.Parmtype = parmtype
	Template_Checkbox.ColumnIndex = args;
		
	local border = Template_Checkbox:CreateTexture(nil, "BACKGROUND")
	border:SetPoint("TOPLEFT", Template_Checkbox, "TOPLEFT", 0, 0)	
	border:SetSize(19,19)
	border:SetTexture(Template_Small_Button_Border, true)
	border:SetTexCoord(0,1,0,1)
	
	Template_Checkbox.Check = CreateFrame("Frame", nil, Template_Checkbox)
	Template_Checkbox.Check:SetPoint("TOPLEFT", Template_Checkbox, "TOPLEFT", -1, 2)
	Template_Checkbox.Check:SetSize(18,18)
	if(initialState) then
		
	else
		Template_Checkbox.Check:Hide()
	end
	-- local checkTexture = Template_Checkbox.Check:CreateTexture(nil, "OVERLAY")
	-- checkTexture:SetAllPoints()
	-- checkTexture:SetColorTexture(0.99,0.82,0.7,1)
	
	 local checkTexture = Template_Checkbox.Check:CreateTexture(nil, "OVERLAY")		
	 checkTexture:SetAllPoints()	
	 checkTexture:SetTexture(130751, true)
	 checkTexture:SetTexCoord(0,1,0,1)
	
	Template_Checkbox.Text = Template_Checkbox:CreateFontString(nil, "ARTWORK")
	Template_Checkbox.Text:SetFont(RepGrinderUI.DefaultFont, 13)
	Template_Checkbox.Text:SetPoint("TOPLEFT", Template_Checkbox, "TOPLEFT", 25, 1)
	Template_Checkbox.Text:SetHeight(15)
	Template_Checkbox.Text:SetTextColor(0.8,0.8,0.8,0.9)
	Template_Checkbox.Text:SetText(text)
	Template_Checkbox:SetScript("OnClick", function (self, ...) RepGrinderUI:ToggleCheckBox(self) RepGrinderUI:UpdateGridSettings(self.Parmtype, self.ColumnIndex, self.IsChecked) end)
	return Template_Checkbox
end

function RepGrinderUI:SetupMinimapButton()		
	RepGrinder.Icon = LibStub("LibDataBroker-1.1"):NewDataObject("RepGrinderIcon", {
		type = "data source",
		text = "RepGrinder",
		icon = "Interface\\ICONS\\INV_Stone_SharpeningStone_01",
		OnClick = function() RepGrinderUI:ToggleDetailWindow() end,
		OnTooltipShow = function(tt)
			tt:AddLine("|cff8C8EFFRepGrinder|r")
			tt:AddLine("|cffffff00Click|r To Open")
		end,
	})
	RepGrinder.MinimapButton = LibStub("LibDBIcon-1.0")
	RepGrinder.MinimapButton:Register("RepGrinder", RepGrinder.Icon, RepGrinderMMButton)	
end


Color = { }
function Color:FromRGBA(r,g,b,a) return r/255, g/255, b/255, a; end
function Color:FromHex(hex, a) if (a == nil) then a = 1.0 end hex = hex:gsub("#","") return tonumber("0x"..hex:sub(1,2))/255, tonumber("0x"..hex:sub(3,4))/255, tonumber("0x"..hex:sub(5,6))/255, a end




